<?php


abstract class BaseTblupdateblogPeer {

	
	const DATABASE_NAME = 'propel';

	
	const TABLE_NAME = 'tblupdateblog';

	
	const CLASS_DEFAULT = 'lib.model.Tblupdateblog';

	
	const NUM_COLUMNS = 7;

	
	const NUM_LAZY_LOAD_COLUMNS = 0;

	
	const UPB_USER = 'tblupdateblog.UPB_USER';

	
	const UPB_ENTRY = 'tblupdateblog.UPB_ENTRY';

	
	const UPB_FROMBLOG = 'tblupdateblog.UPB_FROMBLOG';

	
	const UPB_FROMCATEGORY = 'tblupdateblog.UPB_FROMCATEGORY';

	
	const UPB_BLOG = 'tblupdateblog.UPB_BLOG';

	
	const UPB_CATEGORY = 'tblupdateblog.UPB_CATEGORY';

	
	const UPB_DATE = 'tblupdateblog.UPB_DATE';

	
	public static $instances = array();

	
	private static $mapBuilder = null;

	
	private static $fieldNames = array (
		BasePeer::TYPE_PHPNAME => array ('UpbUser', 'UpbEntry', 'UpbFromblog', 'UpbFromcategory', 'UpbBlog', 'UpbCategory', 'UpbDate', ),
		BasePeer::TYPE_STUDLYPHPNAME => array ('upbUser', 'upbEntry', 'upbFromblog', 'upbFromcategory', 'upbBlog', 'upbCategory', 'upbDate', ),
		BasePeer::TYPE_COLNAME => array (self::UPB_USER, self::UPB_ENTRY, self::UPB_FROMBLOG, self::UPB_FROMCATEGORY, self::UPB_BLOG, self::UPB_CATEGORY, self::UPB_DATE, ),
		BasePeer::TYPE_FIELDNAME => array ('upb_user', 'upb_entry', 'upb_fromblog', 'upb_fromcategory', 'upb_blog', 'upb_category', 'upb_date', ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	private static $fieldKeys = array (
		BasePeer::TYPE_PHPNAME => array ('UpbUser' => 0, 'UpbEntry' => 1, 'UpbFromblog' => 2, 'UpbFromcategory' => 3, 'UpbBlog' => 4, 'UpbCategory' => 5, 'UpbDate' => 6, ),
		BasePeer::TYPE_STUDLYPHPNAME => array ('upbUser' => 0, 'upbEntry' => 1, 'upbFromblog' => 2, 'upbFromcategory' => 3, 'upbBlog' => 4, 'upbCategory' => 5, 'upbDate' => 6, ),
		BasePeer::TYPE_COLNAME => array (self::UPB_USER => 0, self::UPB_ENTRY => 1, self::UPB_FROMBLOG => 2, self::UPB_FROMCATEGORY => 3, self::UPB_BLOG => 4, self::UPB_CATEGORY => 5, self::UPB_DATE => 6, ),
		BasePeer::TYPE_FIELDNAME => array ('upb_user' => 0, 'upb_entry' => 1, 'upb_fromblog' => 2, 'upb_fromcategory' => 3, 'upb_blog' => 4, 'upb_category' => 5, 'upb_date' => 6, ),
		BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, )
	);

	
	public static function getMapBuilder()
	{
		if (self::$mapBuilder === null) {
			self::$mapBuilder = new TblupdateblogMapBuilder();
		}
		return self::$mapBuilder;
	}
	
	static public function translateFieldName($name, $fromType, $toType)
	{
		$toNames = self::getFieldNames($toType);
		$key = isset(self::$fieldKeys[$fromType][$name]) ? self::$fieldKeys[$fromType][$name] : null;
		if ($key === null) {
			throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(self::$fieldKeys[$fromType], true));
		}
		return $toNames[$key];
	}

	

	static public function getFieldNames($type = BasePeer::TYPE_PHPNAME)
	{
		if (!array_key_exists($type, self::$fieldNames)) {
			throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
		}
		return self::$fieldNames[$type];
	}

	
	public static function alias($alias, $column)
	{
		return str_replace(TblupdateblogPeer::TABLE_NAME.'.', $alias.'.', $column);
	}

	
	public static function addSelectColumns(Criteria $criteria)
	{

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_USER);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_ENTRY);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_FROMBLOG);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_FROMCATEGORY);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_BLOG);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_CATEGORY);

		$criteria->addSelectColumn(TblupdateblogPeer::UPB_DATE);

	}

	
	public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
	{
				$criteria = clone $criteria;

								$criteria->setPrimaryTableName(TblupdateblogPeer::TABLE_NAME);

		if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
			$criteria->setDistinct();
		}

		if (!$criteria->hasSelectClause()) {
			TblupdateblogPeer::addSelectColumns($criteria);
		}

		$criteria->clearOrderByColumns(); 		$criteria->setDbName(self::DATABASE_NAME); 
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
				$stmt = BasePeer::doCount($criteria, $con);

		if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$count = (int) $row[0];
		} else {
			$count = 0; 		}
		$stmt->closeCursor();
		return $count;
	}
	
	public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
	{
		$critcopy = clone $criteria;
		$critcopy->setLimit(1);
		$objects = TblupdateblogPeer::doSelect($critcopy, $con);
		if ($objects) {
			return $objects[0];
		}
		return null;
	}
	
	public static function doSelect(Criteria $criteria, PropelPDO $con = null)
	{
		return TblupdateblogPeer::populateObjects(TblupdateblogPeer::doSelectStmt($criteria, $con));
	}
	
	public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}

		if (!$criteria->hasSelectClause()) {
			$criteria = clone $criteria;
			TblupdateblogPeer::addSelectColumns($criteria);
		}

				$criteria->setDbName(self::DATABASE_NAME);

				return BasePeer::doSelect($criteria, $con);
	}
	
	public static function addInstanceToPool(Tblupdateblog $obj, $key = null)
	{
		if (Propel::isInstancePoolingEnabled()) {
			if ($key === null) {
				$key = serialize(array((string) $obj->getUpbUser(), (string) $obj->getUpbEntry()));
			} 			self::$instances[$key] = $obj;
		}
	}

	
	public static function removeInstanceFromPool($value)
	{
		if (Propel::isInstancePoolingEnabled() && $value !== null) {
			if (is_object($value) && $value instanceof Tblupdateblog) {
				$key = serialize(array((string) $value->getUpbUser(), (string) $value->getUpbEntry()));
			} elseif (is_array($value) && count($value) === 2) {
								$key = serialize(array((string) $value[0], (string) $value[1]));
			} else {
				$e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or Tblupdateblog object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
				throw $e;
			}

			unset(self::$instances[$key]);
		}
	} 
	
	public static function getInstanceFromPool($key)
	{
		if (Propel::isInstancePoolingEnabled()) {
			if (isset(self::$instances[$key])) {
				return self::$instances[$key];
			}
		}
		return null; 	}
	
	
	public static function clearInstancePool()
	{
		self::$instances = array();
	}
	
	
	public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
	{
				if ($row[$startcol + 0] === null && $row[$startcol + 1] === null) {
			return null;
		}
		return serialize(array((string) $row[$startcol + 0], (string) $row[$startcol + 1]));
	}

	
	public static function populateObjects(PDOStatement $stmt)
	{
		$results = array();
	
				$cls = TblupdateblogPeer::getOMClass();
		$cls = substr('.'.$cls, strrpos('.'.$cls, '.') + 1);
				while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
			$key = TblupdateblogPeer::getPrimaryKeyHashFromRow($row, 0);
			if (null !== ($obj = TblupdateblogPeer::getInstanceFromPool($key))) {
																$results[] = $obj;
			} else {
		
				$obj = new $cls();
				$obj->hydrate($row);
				$results[] = $obj;
				TblupdateblogPeer::addInstanceToPool($obj, $key);
			} 		}
		$stmt->closeCursor();
		return $results;
	}
	
	public static function getTableMap()
	{
		return Propel::getDatabaseMap(self::DATABASE_NAME)->getTable(self::TABLE_NAME);
	}

	
	public static function getOMClass()
	{
		return TblupdateblogPeer::CLASS_DEFAULT;
	}

	
	public static function doInsert($values, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		if ($values instanceof Criteria) {
			$criteria = clone $values; 		} else {
			$criteria = $values->buildCriteria(); 		}


				$criteria->setDbName(self::DATABASE_NAME);

		try {
									$con->beginTransaction();
			$pk = BasePeer::doInsert($criteria, $con);
			$con->commit();
		} catch(PropelException $e) {
			$con->rollBack();
			throw $e;
		}

		return $pk;
	}

	
	public static function doUpdate($values, PropelPDO $con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		$selectCriteria = new Criteria(self::DATABASE_NAME);

		if ($values instanceof Criteria) {
			$criteria = clone $values; 
			$comparison = $criteria->getComparison(TblupdateblogPeer::UPB_USER);
			$selectCriteria->add(TblupdateblogPeer::UPB_USER, $criteria->remove(TblupdateblogPeer::UPB_USER), $comparison);

			$comparison = $criteria->getComparison(TblupdateblogPeer::UPB_ENTRY);
			$selectCriteria->add(TblupdateblogPeer::UPB_ENTRY, $criteria->remove(TblupdateblogPeer::UPB_ENTRY), $comparison);

		} else { 			$criteria = $values->buildCriteria(); 			$selectCriteria = $values->buildPkeyCriteria(); 		}

				$criteria->setDbName(self::DATABASE_NAME);

		return BasePeer::doUpdate($selectCriteria, $criteria, $con);
	}

	
	public static function doDeleteAll($con = null)
	{
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}
		$affectedRows = 0; 		try {
									$con->beginTransaction();
			$affectedRows += BasePeer::doDeleteAll(TblupdateblogPeer::TABLE_NAME, $con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	 public static function doDelete($values, PropelPDO $con = null)
	 {
		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
		}

		if ($values instanceof Criteria) {
												TblupdateblogPeer::clearInstancePool();

						$criteria = clone $values;
		} elseif ($values instanceof Tblupdateblog) {
						TblupdateblogPeer::removeInstanceFromPool($values);
						$criteria = $values->buildPkeyCriteria();
		} else {
			


			$criteria = new Criteria(self::DATABASE_NAME);
												if (count($values) == count($values, COUNT_RECURSIVE)) {
								$values = array($values);
			}

			foreach ($values as $value) {

				$criterion = $criteria->getNewCriterion(TblupdateblogPeer::UPB_USER, $value[0]);
				$criterion->addAnd($criteria->getNewCriterion(TblupdateblogPeer::UPB_ENTRY, $value[1]));
				$criteria->addOr($criterion);

								TblupdateblogPeer::removeInstanceFromPool($value);
			}
		}

				$criteria->setDbName(self::DATABASE_NAME);

		$affectedRows = 0; 
		try {
									$con->beginTransaction();
			
			$affectedRows += BasePeer::doDelete($criteria, $con);

			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollBack();
			throw $e;
		}
	}

	
	public static function doValidate(Tblupdateblog $obj, $cols = null)
	{
		$columns = array();

		if ($cols) {
			$dbMap = Propel::getDatabaseMap(TblupdateblogPeer::DATABASE_NAME);
			$tableMap = $dbMap->getTable(TblupdateblogPeer::TABLE_NAME);

			if (! is_array($cols)) {
				$cols = array($cols);
			}

			foreach ($cols as $colName) {
				if ($tableMap->containsColumn($colName)) {
					$get = 'get' . $tableMap->getColumn($colName)->getPhpName();
					$columns[$colName] = $obj->$get();
				}
			}
		} else {

		}

		$res =  BasePeer::doValidate(TblupdateblogPeer::DATABASE_NAME, TblupdateblogPeer::TABLE_NAME, $columns);
    if ($res !== true) {
        $request = sfContext::getInstance()->getRequest();
        foreach ($res as $failed) {
            $col = TblupdateblogPeer::translateFieldname($failed->getColumn(), BasePeer::TYPE_COLNAME, BasePeer::TYPE_PHPNAME);
            $request->setError($col, $failed->getMessage());
        }
    }

    return $res;
	}

	
	public static function retrieveByPK($upb_user, $upb_entry, PropelPDO $con = null) {
		$key = serialize(array((string) $upb_user, (string) $upb_entry));
 		if (null !== ($obj = TblupdateblogPeer::getInstanceFromPool($key))) {
 			return $obj;
		}

		if ($con === null) {
			$con = Propel::getConnection(TblupdateblogPeer::DATABASE_NAME, Propel::CONNECTION_READ);
		}
		$criteria = new Criteria(TblupdateblogPeer::DATABASE_NAME);
		$criteria->add(TblupdateblogPeer::UPB_USER, $upb_user);
		$criteria->add(TblupdateblogPeer::UPB_ENTRY, $upb_entry);
		$v = TblupdateblogPeer::doSelect($criteria, $con);

		return !empty($v) ? $v[0] : null;
	}
} 

Propel::getDatabaseMap(BaseTblupdateblogPeer::DATABASE_NAME)->addTableBuilder(BaseTblupdateblogPeer::TABLE_NAME, BaseTblupdateblogPeer::getMapBuilder());

